﻿/*
	File: Diktor.js
	Copyright: Filipp Lepalaan (filipp@mac.com) 2006
	Simple controller class for the Dict.org Wdiget
	
	TODO
	- Fixed scrolling and resizing
*/

var x, y;
var spinner, stretcher;
var minHeight, minWidth, growboxInset;
var databaseIndex, strategyIndex;
var currList, currRpp, currResultFormat;
var req, baseUrl, scrollBarDiv, gDoneButton, gInfoButton;
var front, back, topDiv, bottomDiv, centerDiv, resultsDiv, messageDiv, searchField;

function loaded ()
{
	minWidth 	= 380;
	minHeight	= 250;
	
	baseUrl = 'http://www.dict.org';
	
	front	= document.getElementById		('front');
	back	= document.getElementById		('back');
	topDiv 	= document.getElementById		('topDiv');
	bottomDiv = document.getElementById		('bottomDiv');
	centerDiv = document.getElementById		('centerDiv');
	resultsDiv = document.getElementById	('resultsDiv');
	messageDiv = document.getElementById	('messageDiv');
	searchField = document.getElementById	('searchField');
	scrollBarDiv = document.getElementById	('scrollBarDiv');
	
	databaseIndex = document.getElementById	('databaseIndex');
	strategyIndex = document.getElementById ('strategyIndex');
	
	stretcher 	= new Stretcher (resultsDiv, 400, 200, stretcherDidFinish);
	
	gDoneButton = new AppleGlassButton (document.getElementById ("doneButton"), "Done", hidePrefs);
	gInfoButton = new AppleInfoButton (document.getElementById ("infoButton"), front, "black", "black", showPrefs);
	
	req = new XMLHttpRequest ();					// Create conn object
	req.onreadystatechange = processReqChange;		// Define the callback
	
	bottomDiv.style.visibility = 'hidden';
	centerDiv.style.visibility = 'hidden';
	
	initPrefs ();
}


function search (string)
{
	if (string.length == 0)  return shrink ();			// Search closed
	
	db		= database[widget.preferenceForKey ('databaseIndex')]['short'];
	strat	= strategy[widget.preferenceForKey ('strategyIndex')]['short'];
	
	url = baseUrl + '/bin/Dict?Form=Dict1&Query='+string+'&Database='+db+'&Strategy='+strat;

	req.open ('GET', url, true);
	req.send (null);

	document.getElementById('spinnerImg').style.display = 'block';
}

function processReqChange () 
{
	//setStatus ('Tegutsen');
    if (req.readyState == 4)				// only if req shows "loaded"
    {
        if (req.status == 200)				// only if "OK"
        {
        	parseResults (req.responseText);
        } else {
        	setResults ('Sorry, the connection failed.');
        }
    }
}

function parseResults (results)
{
	regexResults = /<pre>[\s\S]*<\/pre>/;
	tmp = regexResults.exec (results);
	regexLink = /<a href="(.*?)">/g;		// Make links absolute and make them work from Dashboard
	newLink = "<a onclick=\"widget.openURL(\'"+baseUrl+"$1\')\">";
	out = tmp[0].replace (regexLink, newLink);
	
	if (!stretcher.isStretched()) stretcher.stretch ();
	
	setResults (out);
	setScrollbar ();
}

function setResults (results)
{
	resultsDiv.innerHTML = results;
}

// Called every time our stretcher changees state
function stretcherDidFinish ()
{	
	(stretcher.isStretched ()) ?  expanded () : collapsed ();	
}

function expanded ()
{	
	bottomDiv.style.visibility 		= 'visible';
	scrollBarDiv.style.visibility 	= 'visible';
	centerDiv.style.visibility 		= 'visible';	
}

function collapsed ()
{
	scrollBarDiv.style.visibility 	= 'hidden';
	centerDiv.style.visibility 		= 'hidden';
	bottomDiv.style.visibility 		= 'hidden';
}

function shrink ()
{	
	if (stretcher.isStretched ()) stretcher.stretch (collapsed ());
}

// Weirdo Apple resizing Functions
var growboxInset;		// tracks where the last mouse position was throughout the drag
var edgeOffset = 20;	// the right & bottom offset of the grow thumb vs. the edge of widget window

// called when the mouse first clicks upon the growbox 
function mouseDown(event)
{
	document.addEventListener ("mousemove", mouseMove, true);  	// begin tracking the move
	document.addEventListener ("mouseup", mouseUp, true);		// and notify when the drag ends

	// growboxInset tracks where the actual mouse click happened vs. the right and 
	// bottom edges of the widget
	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};

	event.stopPropagation ();
	event.preventDefault ();
}

// called as the mouse button is down and the mouse moves
function mouseMove(event)
{
	
	// checks if the reported event data is legit or not
	if ((event.x == -1) && ( Math.abs( Math.abs(y-growboxInset.y) - Math.abs(event.y) ) > 2 ) ) { break; }

	// x and y track where bottom-right corner of the widget should be, with relation
	// to the event.
	x = event.x + growboxInset.x;
	y = event.y + growboxInset.y;
		
	if (x < minWidth) x = minWidth;		// an arbitrary minimum width

	if (y < minHeight) y = minHeight;	// an arbitrary minimum height
		
	// Moves the coordinates div accordingly
	bottomDiv.style.top = (y-edgeOffset);
 
	window.resizeTo (x,y);		// resizes the widget's window

	updateCoordinates ();		// updates the coordinate display in the bottom-right
	
	event.stopPropagation ();
	event.preventDefault ();
	
}

// called after the mouse button is released 
function mouseUp(event)
{
	document.removeEventListener ("mousemove", mouseMove, true); // stop tracking the move
	document.removeEventListener ("mouseup", mouseUp, true);		// and notify if the mouse goes down again
	
	widget.setPreferenceForKey (event.x, 'x');
	widget.setPreferenceForKey (event.y, 'y');
	
	event.stopPropagation ();
	event.preventDefault ();
	
	scrollArea.refresh ();			// Thanks, Lutin!
}

// Borrowed from Scroller.wdgt
function setScrollbar()
{
	scrollbar 	= new AppleVerticalScrollbar (scrollBarDiv);
	scrollArea	= new AppleScrollArea (resultsDiv, scrollbar);
	
	scrollArea.singlepressScrollPixels	= 15;
	scrollArea.scrollsHorizontally		= false;
	scrollArea.focus();											// for key control when first loading in Safari
	
	window.onfocus	= function ()	{ scrollArea.focus (); }
	window.onblur	= function ()	{ scrollArea.blur (); }
}

function setDescription(id)
{
	listDescription.innerHTML = mailingLists[id]['long'];
}

// Preferences
function initPrefs ()
{
	if (!widget.preferenceForKey ('databaseIndex'))		// First launch - setup defaults
	{
		widget.setPreferenceForKey (0, 'databaseIndex');
		widget.setPreferenceForKey (0, 'strategyIndex');
	}
	
	for (i = 0; i < database.length; i++)
	{
		var element = document.createElement ("option");
		element.value = i;
		element.innerText = database[i]['long'];
		databaseIndex.appendChild (element);
	}
	
	for (i = 0; i < strategy.length; i++)
	{
		var element = document.createElement ("option");
		element.value = i;
		element.innerText = strategy[i]['long'];
		strategyIndex.appendChild (element);
	}
	
	databaseIndex.selectedIndex = widget.preferenceForKey ('databaseIndex');
	strategyIndex.selectedIndex = widget.preferenceForKey ('strategyIndex');
}

function showPrefs()
{
    if (window.widget) widget.prepareForTransition ("ToBack");
    
    front.style.display	= "none";
    back.style.display	= "block";
    
    if (window.widget) setTimeout ('widget.performTransition();', 0);  

}

function hidePrefs()
{
	widget.setPreferenceForKey (databaseIndex.value, 'databaseIndex');
	widget.setPreferenceForKey (strategyIndex.value, 'strategyIndex');
	
    if (window.widget) widget.prepareForTransition ("ToFront");
	
	back.style.display	= "none";
    front.style.display	= "block";
    
    if (window.widget) setTimeout ('widget.performTransition();', 0);
}